﻿// The directory that contains the theme to be used.
var CONFIG_THEME_DIR = 'default'; 
// Maximum approval entries to parse and display.
var CONFIG_MAX_ENTRIES = 10; 

// "Pathify"s filename with given path.
function pathify(path, filename) {
  return path + '\\' + filename;
} 

function SimpleXmlParser(xmlDoc) {
  this.xmlDoc = xmlDoc; 
  this.parseError = xmlDoc.parseError;
  if (this.parseError.errorCode !== 0) {
     //debug.error("SimpleXmlParser ERROR: " + this.parseError.reason);
  }
}

SimpleXmlParser.prototype.getItems = function(key) {
  var xmlDoc = this.xmlDoc;
  var items = [];
  if (this.parseError.errorCode !== 0) {
     //debug.error("SimpleXmlParser ERROR: " + this.parseError.reason);
  } else {
     var objNodeList = xmlDoc.getElementsByTagName(key);
     for (var i = 0; i < objNodeList.length; ++i) {
       var xmlItem = objNodeList.item(i);
       var item = {};
       var added = false;
       for (var j = 0; j < xmlItem.childNodes.length; ++j) {
         var child = xmlItem.childNodes.item(j);
         if (child.childNodes.length > 0) {
           var name = child.nodeName;
           var value = child.childNodes[0].nodeValue;
           item[name] = value;
           added = true;
         }
       }
       if (added) {
         items.push(item);     
       }
     }
  } 
  return items;
}; 

// Determines whether file is present in gadget package.
function isFilePresent(path) {
  var result = gadget.storage.extract(path);
  
  return result !== '';
}

// A shameful way to determine the dimensions (width/height) of an image.
// - path: Path to image.
//
// Returns an array with [width, height].
function getImageDimensions(path) {
  // NOTE: Uses a hidden "img" element defined in "main.xml".
  imgSizer.src = path;

  return [imgSizer.srcWidth, imgSizer.srcHeight];
}

// Formats date object similar to how contentarea displays dates, i.e.:
//   - 15 min ago
//   - 3 hrs ago
//   - 5 days ago
//
// Returns empty string on error.
function formatDate(date) {
  if (!date) {
    return '';
  }

  var now = new Date();
  var value;

  // Difference between now and supplied date in ms.
  var diff = now.getTime() - date.getTime();

  // Convert to min.
  diff = diff / (60 * 1000);

  // Less than an hour.
  if (diff < 60) {
    value = Math.floor(diff);
    return value + ' ' + (value > 1 ? strings.MINS_AGO : strings.MIN_AGO);
  }

  // Convert to hours.
  diff = Math.floor(diff / 60);

  // Less than a day.
  if (diff < 24) {
    value = Math.floor(diff);
    return value + ' ' + (value > 1 ? strings.HRS_AGO : strings.HR_AGO);
  }

  // Convert to days.
  value = Math.floor(diff / 24);

  // Default unit is day.
  return value + ' ' + (value > 1 ? strings.DAYS_AGO : strings.DAY_AGO);
} 