﻿function getIconSrc16(objectName) {
	var smallObjectName = objectName.toLowerCase();

	if (smallObjectName == "account") {
		return "Salesforce/icons/accounts16.png";
	} else if (smallObjectName == "campaign") {
		return "Salesforce/icons/campaigns16.png";
	} else if (smallObjectName == "case") {
		return "Salesforce/icons/cases16.png";
	} else if (smallObjectName == "contact") {
		return "Salesforce/icons/contacts16.png";
	} else if (smallObjectName == "contract") {
		return "Salesforce/icons/contracts16.png";
	} else if (smallObjectName == "lead") {
		return "Salesforce/icons/leads16.png";
	} else if (smallObjectName == "opportunity") {
		return "Salesforce/icons/opportunities16.png";
	} else if (smallObjectName == "product") {
		return "Salesforce/icons/products16.png";
	} else if (smallObjectName == "solution") {
		return "Salesforce/icons/solutions16.png";
	} else {
		return null;
	}
}

function getIconSrc32(objectName) {
	var smallObjectName = objectName.toLowerCase();

	if (smallObjectName == "account") {
		return "https://na1.salesforce.com/img/icon/accounts32.png";
	} else if (smallObjectName == "campaign") {
		return "https://na1.salesforce.com/img/icon/campaigns32.png";
	} else if (smallObjectName == "case") {
		return "https://na1.salesforce.com/img/icon/cases32.png";
	} else if (smallObjectName == "contact") {
		return "https://na1.salesforce.com/img/icon/contacts32.png";
	} else if (smallObjectName == "contract") {
		return "https://na1.salesforce.com/img/icon/contracts32.png";
	} else if (smallObjectName == "lead") {
		return "https://na1.salesforce.com/img/icon/leads32.png";
	} else if (smallObjectName == "opportunity") {
		return "https://na1.salesforce.com/img/icon/opportunities32.png";
	} else if (smallObjectName == "product") {
		return "https://na1.salesforce.com/img/icon/products32.png";
	} else if (smallObjectName == "solution") {
		return "https://na1.salesforce.com/img/icon/solutions32.png";
	} else {
		return null;
	}
}

function getFieldListByLayouts(detailLayouts) {
	var fields = new Array();
	for(var i=0; i<detailLayouts.length; i++) {
		// layout rows
		var rowsDesc = detailLayouts[i].getArray("layoutRows");
		// loop by rows
		for(var j=0; j<rowsDesc.length; j++) {
			var items = rowsDesc[j].getArray("layoutItems");
			// loop by layout components
			for(var k=0; k<items.length; k++) {
				if (items[k].placeholder=="false") {
					var components = items[k].getArray("layoutComponents");
					for(var l=0; l<components.length; l++) {
						if (components[l].type=="Field") {
							fields[fields.length] = components[l].value;
						}
					}
				}
			}
		}
	}
	// list of fields
	return fields.join(",");
}

function generateDetailContent(resultData, detailLayouts) {
	var html = "";
	for(var i=0; i<detailLayouts.length; i++) {
		// layout rows
		var rowsDesc = detailLayouts[i].getArray("layoutRows");
		// loop by rows
		for(var j=0; j<rowsDesc.length; j++) {
			html += "<tr>";
			var items = rowsDesc[j].getArray("layoutItems");
			// loop by layout components
			for(var k=0; k<items.length; k++) {
				if (items[k].placeholder=="false") {
					html += "<td class='labelCol'>" + items[k].label + "</td>";
					html += "<td class='dataCol'>&nbsp;";
					var components = items[k].getArray("layoutComponents");
					for(var l=0; l<components.length; l++) {
						if (components[l].type=="Field") {
							if (resultData[components[l].value]==null) {
								html += "&nbsp;";
							} else {
								html += resultData[components[l].value];
							}
						} else if (components[l].type=="Separator") {
							html += components[l].value;
						}
					}
					html += "</td>";
				} else {
					html += "<td class='labelCol empty'>&nbsp;</td>";
					html += "<td class='dataCol empty'>&nbsp;</td>";
				}
			}
			html += "</tr>";
		}
	}	
	return html;
}